| optoMDC

Loading...
Searching...
No Matches
optoMDC.registers.mre3_registers.PID Class Reference
Inheritance diagram for optoMDC.registers.mre3_registers.PID:

## Public Member Functions
| __init__ (self, int channel=0, board=None)
| GetPositionLimit (self)
| SetPositionLimit (self, value)
| GetVelocityLimit (self)
| SetVelocityLimit (self, value)

## Static Public Member Functions
| help ()

## Public Attributes
int | sys_id = 0xB8 | channel
dict | inverted_out
dict | kp
dict | ki
dict | kd
dict | min_output
dict | max_output
dict | min_integral
dict | max_integral
dict | enable_filter
dict | cutoff_frequency
dict | position_limit
dict | position_error
dict | velocity_limit
dict | velocity
| name = self.__class__.__name__

## Protected Attributes
bool | _readonly = False

## Detailed Description

    Control Mode Channel - OF PID Control (with/without Temperature Compensation)
    System ID: 0xB8 through 0xBf

    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | Register Name      | Id   | Type        | Unit | Range | Default | Comment                                          |
    +====================+======+=============+======+=======+=========+==================================================+
    | inverted_out       | 0x00 |boolean      |None  |       |   0     | Defines whether PID output is inverted (* -1) or not|
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | kp                 | 0x01 |float 32-bit |None  |       |   10.0  |                                                  |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | ki                 | 0x02 |float 32-bit |None  |       |   200.0 |                                                  |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | kd                 | 0x03 |float 32-bit |None  |       |   0.04  |                                                  |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | min_output         | 0x04 |float 32-bit |None  |       |         | If PID output reaches this, it is clamped to this|
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | max_output         | 0x05 |float 32-bit |None  |       |         | If PID output reaches this, it is clamped to this|
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | min_integral       | 0x06 |float 32-bit |None  |       |         |                                                  |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | max_integral       | 0x07 |float 32-bit |None  |       |         |                                                  |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | Enable filter      | 0x13 |boolean      |None  |       | true    | Enables / disables filter on derivate term       |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | Cutoff frequency   | 0x14 |float 32-bit |None  |       | 800.0   | Sets cut-off frequency in Hz                     |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | PID system output  | 0x17 |float 32-bit |None  |       | 0       | Actual output value at PID output                |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | Position Stability Limit Channel 0-1  | 0x19   |float 32-bit     |None  |       | 0.05       | Maximum allowable position error on channel for Mirror stable state.                |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | Position Error Channel 0-1            | 0x1A |float 32-bit |None  |       | 0       | Actual position error on channel               |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | Velocity Stability Limit Channel 0-1  | 0x1B |float 32-bit |None  |       | 2.0       | Maximum allowable velocity on channel for Mirror stable state                |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+
    | Velocity (OF Time Derivative) Channel 0-1  | 0x1C |float 32-bit |None  |       | 0       | Actual velocity on channel, Feedback signal time derivative. Used for mirror stable condition                |
    +--------------------+------+-------------+------+-------+---------+--------------------------------------------------+

## Constructor & Destructor Documentation

## ◆ __init__()

optoMDC.registers.mre3_registers.PID.__init__ | ( |  | self,
|  | int | channel = 0,
|  |  | board = None )

## Member Function Documentation

## ◆ GetPositionLimit()

optoMDC.registers.mre3_registers.PID.GetPositionLimit | ( |  | self | ) |

## ◆ GetVelocityLimit()

optoMDC.registers.mre3_registers.PID.GetVelocityLimit | ( |  | self | ) |

## ◆ help()

optoMDC.registers.mre3_registers.PID.help | ( |  | ) |
| static

## ◆ SetPositionLimit()

optoMDC.registers.mre3_registers.PID.SetPositionLimit | ( |  | self,
|  |  | value )

## ◆ SetVelocityLimit()

optoMDC.registers.mre3_registers.PID.SetVelocityLimit | ( |  | self,
|  |  | value )

## Member Data Documentation

## ◆ _readonly

bool optoMDC.registers.mre3_registers.PID._readonly = False
| protected

## ◆ cutoff_frequency

dict optoMDC.registers.mre3_registers.PID.cutoff_frequency

Initial value:
= {'id': self.sys_id << 8 | 0x14,
'type': float,
'unit': None,
'range': None,
'default': 800.0,
'value': 800.0}

## ◆ enable_filter

dict optoMDC.registers.mre3_registers.PID.enable_filter

Initial value:
= {'id': self.sys_id << 8 | 0x13,
'type': bool,
'unit': None,
'range': None,
'default': True,
'value': True}

## ◆ inverted_out

dict optoMDC.registers.mre3_registers.PID.inverted_out

Initial value:
= {'id': self.sys_id << 8 | 0x00,
'type': bool,
'unit': None,
'range': None,
'default': 0,
'value': 0}

## ◆ kd

dict optoMDC.registers.mre3_registers.PID.kd

Initial value:
= {'id': self.sys_id << 8 | 0x03,
'type': float,
'unit': None,
'range': None,
'default': 0.04,
'value': 0.04}

## ◆ ki

dict optoMDC.registers.mre3_registers.PID.ki

Initial value:
= {'id': self.sys_id << 8 | 0x02,
'type': float,
'unit': None,
'range': None,
'default': 200.0,
'value': 200.0}

## ◆ kp

dict optoMDC.registers.mre3_registers.PID.kp

Initial value:
= {'id': self.sys_id << 8 | 0x01,
'type': float,
'unit': None,
'range': None,
'default': 10.0,
'value': 10.0}

## ◆ max_integral

dict optoMDC.registers.mre3_registers.PID.max_integral

Initial value:
= {'id': self.sys_id << 8 | 0x07,
'type': float,
'unit': None,
'range': None,
'default': 1.701411735e+38,
'value': 0}

## ◆ max_output

dict optoMDC.registers.mre3_registers.PID.max_output

Initial value:
= {'id': self.sys_id << 8 | 0x05,
'type': float,
'unit': None,
'range': None,
'default': 1.0,
'value': 1.0}

## ◆ min_integral

dict optoMDC.registers.mre3_registers.PID.min_integral

Initial value:
= {'id': self.sys_id << 8 | 0x06,
'type': float,
'unit': None,
'range': None,
'default': -1.701411735e+38,
'value': 0}

## ◆ min_output

dict optoMDC.registers.mre3_registers.PID.min_output

Initial value:
= {'id': self.sys_id << 8 | 0x04,
'type': float,
'unit': None,
'range': None,
'default': -1.0,
'value': -1.0}

## ◆ name

optoMDC.registers.mre3_registers.PID.name = self.__class__.__name__

## ◆ position_error

dict optoMDC.registers.mre3_registers.PID.position_error

Initial value:
= {'id': self.sys_id << 8 | 0x1A,
'type': float,
'unit': None,
'range': None,
'default': 0.0,
'value': 0.0}

## ◆ position_limit

dict optoMDC.registers.mre3_registers.PID.position_limit

Initial value:
= {'id': self.sys_id << 8 | 0x19,
'type': float,
'unit': None,
'range': None,
'default': 0.05,
'value': 0.05}

## ◆ sys_id

int optoMDC.registers.mre3_registers.PID.sys_id = 0xB8 | channel

## ◆ velocity

dict optoMDC.registers.mre3_registers.PID.velocity

Initial value:
= {'id': self.sys_id << 8 | 0x1C,
'type': float,
'unit': None,
'range': None,
'default': 0.0,
'value': 0.0}

## ◆ velocity_limit

dict optoMDC.registers.mre3_registers.PID.velocity_limit

Initial value:
= {'id': self.sys_id << 8 | 0x1B,
'type': float,
'unit': None,
'range': None,
'default': 2.0,
'value': 2.0}

The documentation for this class was generated from the following file:

- C:/git/138-882-00_optoMDC/src/main/python/optoMDC/registers/mre3_registers.py